<?php

namespace Drupal\billwerk_subscriptions_subscriptionjs\Form;

use Drupal\billwerk_subscriptions\Environment;
use Drupal\billwerk_subscriptions_entities\SubscriptionPlansManager;
use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Session\AccountInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Parent class for ZMP Billwerk Forms.
 */
abstract class BillwerkSubscriptionjsFormAbstract extends FormBase {
	public function __construct(
    // @improve:
		// These should be "readonly", but that's currently not possible on
		// multipage forms due to a dependency injection bug leading to an error:
		// Error: Cannot initialize readonly property Drupal\billwerk_subscriptions_subscriptionjs\Form\BillwerkSubscriptionjsFormAbstract::$account from scope Drupal\Core\Form\FormBase in Drupal\Core\Form\FormBase->__wakeup() (line 89 of core/lib/Drupal/Core/DependencyInjection/DependencySerializationTrait.php).
		protected AccountInterface $account,
		protected SubscriptionPlansManager $subscriptionPlansManager,
		protected Environment $environment) {

	}

	/**
	 * {@inheritdoc}
	 */
	public static function create(ContainerInterface $container) {
		return new static(
			$container->get('current_user'),
			$container->get('billwerk_subscriptions_entities.subscription_plans_manager'),
			$container->get('billwerk_subscriptions.environment'),
		);
	}

	public function buildForm(array $form, FormStateInterface $form_state) {
		// Add this library to prevent duplicate form submits:
		$form['#attached']['library'][] = 'core/drupal.form';
	}
}
