<?php

namespace Drupal\billwerk_subscriptions_subscriptionjs\Form;

use Drupal\billwerk_subscriptions_subscriptionjs\Form\BillwerkSubscriptionjsFormAbstract;
use Drupal\Core\Access\AccessResult;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Session\AccountInterface;

/**
 * The addon upgrade form.
 */
class ComponentsForm extends BillwerkSubscriptionjsFormAbstract {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'billwerk_subscriptions_subscriptionjs_components_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    // @todo
    $currentAddonKeys = [];

    $form['addon_ids'] = [
      '#type' => 'radios',
      '#title' => $this->t('Addon'),
      '#options' => $this->subscriptionPlansManager->getComponentsSubscribeSelectOptions($currentAddonKeys),
      '#multiple' => TRUE,
      '#description' => $this->t('Select the add-ons to add to your subscription.'),
      '#required' => TRUE,
    ];

    $form['actions']['#type'] = 'actions';
    $form['actions']['submit'] = [
      '#type' => 'submit',
      '#value' => $this->t('Buy now'),
      '#button_type' => 'secondary',
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    // @todo Execute the required JS action or redirect.
  }

  /**
	 * Checks access for a specific request.
	 *
	 * @param \Drupal\Core\Session\AccountInterface $account
	 *   Run access checks for this account.
	 *
	 * @return \Drupal\Core\Access\AccessResultInterface
	 *   The access result.
	 */
	public static function access(AccountInterface $account) {
    // @todo: Implement!
		return AccessResult::allowed();
	}
}
